Index: trunk/lib/App.inc.php
===================================================================
--- trunk/lib/App.inc.php	(revision 124)
+++ trunk/lib/App.inc.php	(revision 136)
@@ -7,5 +7,5 @@
  *
  * @author  Quinn Comendant <quinn@strangecode.com>
- * @version 2.0
+ * @version 2.1
  */
 
@@ -22,8 +22,8 @@
 class App {
 
-    // Name of this application.
-    var $app = '_app_';
-
-    // If App::start has run successfully.
+    // Namespace of this application instance.
+    var $_ns;
+
+    // If $app->start has run successfully.
     var $running = false;
 
@@ -34,5 +34,5 @@
     var $_carry_queries = array();
 
-    // Hash of global application parameters.
+    // Dictionary of global application parameters.
     var $_params = array();
 
@@ -45,8 +45,8 @@
         'site_url' => '', // URL automatically determined by _SERVER['HTTP_HOST'] if not set here.
 
-        // The location the user will go if the system doesn't knew where else to send them.
+        // The location the user will go if the system doesn't know where else to send them.
         'redirect_home_url' => '/',
 
-        // SSL URL used when redirecting with App::sslOn().
+        // SSL URL used when redirecting with $app->sslOn().
         'ssl_domain' => null,
         'ssl_enabled' => false,
@@ -86,5 +86,5 @@
         'db_create_tables' => true,
 
-        // The level of error reporting. Don't set this to 0 to suppress messages, instead use display_errors to control display.
+        // The level of error reporting. Don't change this to suppress messages, instead use display_errors to control display.
         'error_reporting' => E_ALL,
 
@@ -99,5 +99,5 @@
 
         // General application log.
-        'log_filename' => 'app_error_log',
+        'log_filename' => 'app_log',
 
         // Logging priority can be any of the following, or false to deactivate:
@@ -122,4 +122,6 @@
 
         // A key for calculating simple cryptographic signatures. Set using as an environment variables in the httpd.conf with 'SetEnv SIGNING_KEY <key>'.
+        // Existing password hashes rely on the same key/salt being used to compare encryptions.
+        // Don't change this unless you know existing hashes or signatures will not be affected!
         'signing_key' => 'aae6abd6209d82a691a9f96384a7634a',
     );
@@ -128,14 +130,15 @@
      * This method enforces the singleton pattern for this class. Only one application is running at a time.
      *
-     * @return  object  Reference to the global SessionCache object.
+     * $param   string  $namespace  Name of this application.
+     * @return  object  Reference to the global Cache object.
      * @access  public
      * @static
      */
-    function &getInstance($app=null)
+    function &getInstance($namespace='')
     {
         static $instance = null;
 
         if ($instance === null) {
-            $instance = new App($app);
+            $instance = new App($namespace);
         }
 
@@ -146,9 +149,8 @@
      * Constructor.
      */
-    function App($app=null)
-    {
-        if (isset($app)) {
-            $this->app .= $app;
-        }
+    function App($namespace='')
+    {
+        // Set namespace of application instance.
+        $this->_ns = '_app_' . $namespace;
 
         // Initialize default parameters.
@@ -164,11 +166,7 @@
     function setParam($param=null)
     {
-        if (!isset($_this) || !is_a($_this, 'App') && !is_subclass_of($_this, 'App')) {
-            $_this =& App::getInstance();
-        }
-
         if (isset($param) && is_array($param)) {
             // Merge new parameters with old overriding only those passed.
-            $_this->_params = array_merge($_this->_params, $param);
+            $this->_params = array_merge($this->_params, $param);
         }
     }
@@ -181,14 +179,10 @@
      * @return  mixed               Parameter value, or null if not existing.
      */
-    function &getParam($param=null)
-    {
-        if (!isset($_this) || !is_a($_this, 'App') && !is_subclass_of($_this, 'App')) {
-            $_this =& App::getInstance();
-        }
-
+    function getParam($param=null)
+    {
         if ($param === null) {
-            return $_this->_params;
-        } else if (isset($_this->_params[$param])) {
-            return $_this->_params[$param];
+            return $this->_params;
+        } else if (isset($this->_params[$param])) {
+            return $this->_params[$param];
         } else {
             trigger_error(sprintf('Parameter is not set: %s', $param), E_USER_NOTICE);
@@ -239,9 +233,7 @@
             }
 
-            // The only instance of the DB object.
+            // There will ever only be one instance of the DB object, and here is where it is instantiated.
             require_once dirname(__FILE__) . '/DB.inc.php';
-
             $this->db =& DB::getInstance();
-
             $this->db->setParam(array(
                 'db_server' => $this->getParam('db_server'),
@@ -270,10 +262,4 @@
         if (true === $this->getParam('enable_session')) {
 
-            // Set the session ID to one provided in GET/POST. This is necessary for linking
-            // between domains and keeping the same session.
-            if ($ses = getFormData($this->getParam('session_name'), false)) {
-                session_id($ses);
-            }
-
             if (true === $this->getParam('enable_db_session_handler') && true === $this->getParam('enable_db')) {
                 // Database session handling.
@@ -295,8 +281,8 @@
             session_start();
 
-            if (!isset($_SESSION[$this->app])) {
+            if (!isset($_SESSION[$this->_ns])) {
                 // Access session data using: $_SESSION['...'].
                 // Initialize here _after_ session has started.
-                $_SESSION[$this->app] = array(
+                $_SESSION[$this->_ns] = array(
                     'messages' => array(),
                     'boomerang' => array('url'),
@@ -324,4 +310,12 @@
         // Character set. This should also be printed in the html header template.
         header('Content-type: text/html; charset=' . $this->getParam('character_set'));
+        
+        // Set the version of the codebase we're using.
+        $codebase_version_file = dirname(__FILE__) . '/../docs/version.txt';
+        if (is_readable($codebase_version_file)) {
+            $codebase_version = trim(file_get_contents($codebase_version_file));
+            header('X-Codebase-Version: ' . $codebase_version);
+            define('CODEBASE_VERSION', $codebase_version);
+        }
 
         $this->running = true;
@@ -360,12 +354,8 @@
     function raiseMsg($message, $type=MSG_NOTICE, $file=null, $line=null)
     {
-        if (!isset($_this) || !is_a($_this, 'App') && !is_subclass_of($_this, 'App')) {
-            $_this =& App::getInstance();
-        }
-
         $message = trim($message);
 
-        if (!$_this->running || '' == $message) {
-            $_this->logMsg(sprintf('Canceled method call %s, application not running or message is an empty string.', __FUNCTION__), LOG_DEBUG, __FILE__, __LINE__);
+        if (!$this->running || '' == $message) {
+            $this->logMsg(sprintf('Canceled method call %s, application not running or message is an empty string.', __FUNCTION__), LOG_NOTICE, __FILE__, __LINE__);
             return false;
         }
@@ -373,14 +363,14 @@
         // Save message in session under unique key to avoid duplicate messages.
         $msg_id = md5($type . $message . $file . $line);
-        $_SESSION[$_this->app]['messages'][$msg_id] = array(
+        $_SESSION[$this->_ns]['messages'][$msg_id] = array(
             'type'    => $type,
             'message' => $message,
             'file'    => $file,
             'line'    => $line,
-            'count'   => (isset($_SESSION[$_this->app]['messages'][$msg_id]['count']) ? (1 + $_SESSION[$_this->app]['messages'][$msg_id]['count']) : 1)
+            'count'   => (isset($_SESSION[$this->_ns]['messages'][$msg_id]['count']) ? (1 + $_SESSION[$this->_ns]['messages'][$msg_id]['count']) : 1)
         );
 
         if (!in_array($type, array(MSG_NOTICE, MSG_SUCCESS, MSG_WARNING, MSG_ERR))) {
-            $_this->logMsg(sprintf('Invalid MSG_* type: %s', $type), LOG_DEBUG, __FILE__, __LINE__);
+            $this->logMsg(sprintf('Invalid MSG_* type: %s', $type), LOG_NOTICE, __FILE__, __LINE__);
         }
     }
@@ -396,18 +386,10 @@
     function getRaisedMessages()
     {
-        if (!isset($_this) || !is_a($_this, 'App') && !is_subclass_of($_this, 'App')) {
-            $_this =& App::getInstance();
-        }
-
-        if (!$_this->running) {
-            $_this->logMsg(sprintf('Canceled method call %s, application not running.', __FUNCTION__), LOG_DEBUG, __FILE__, __LINE__);
-            return false;
-        }
-        
-        $output = array();
-        while (isset($_SESSION[$_this->app]['messages']) && $message = array_shift($_SESSION[$_this->app]['messages'])) {
-            $output[] = $message;
-        }
-        return $output;
+        if (!$this->running) {
+            $this->logMsg(sprintf('Canceled method call %s, application not running.', __FUNCTION__), LOG_NOTICE, __FILE__, __LINE__);
+            return false;
+        }
+
+        return isset($_SESSION[$this->_ns]['messages']) ? $_SESSION[$this->_ns]['messages'] : array();
     }
     
@@ -421,14 +403,10 @@
     function clearRaisedMessages()
     {
-        if (!isset($_this) || !is_a($_this, 'App') && !is_subclass_of($_this, 'App')) {
-            $_this =& App::getInstance();
-        }
-
-        if (!$_this->running) {
-            $_this->logMsg(sprintf('Canceled method call %s, application not running.', __FUNCTION__), LOG_DEBUG, __FILE__, __LINE__);
+        if (!$this->running) {
+            $this->logMsg(sprintf('Canceled method call %s, application not running.', __FUNCTION__), LOG_NOTICE, __FILE__, __LINE__);
             return false;
         }
         
-        $_SESSION[$_this->app]['messages'] = array();
+        $_SESSION[$this->_ns]['messages'] = array();
     }
 
@@ -442,34 +420,31 @@
     function printRaisedMessages()
     {
-        if (!isset($_this) || !is_a($_this, 'App') && !is_subclass_of($_this, 'App')) {
-            $_this =& App::getInstance();
-        }
-
-        if (!$_this->running) {
-            $_this->logMsg(sprintf('Canceled method call %s, application not running.', __FUNCTION__), LOG_DEBUG, __FILE__, __LINE__);
-            return false;
-        }
-
-        while (isset($_SESSION[$_this->app]['messages']) && $message = array_shift($_SESSION[$_this->app]['messages'])) {
+        if (!$this->running) {
+            $this->logMsg(sprintf('Canceled method call %s, application not running.', __FUNCTION__), LOG_NOTICE, __FILE__, __LINE__);
+            return false;
+        }
+        
+        $messages = $this->getRaisedMessages();
+        foreach ($messages as $m) {
             ?><div class="sc-msg"><?php
-            if (error_reporting() > 0 && $_this->getParam('display_errors')) {
-                echo "\n<!-- [" . $message['file'] . ' : ' . $message['line'] . '] -->';
-            }
-            switch ($message['type']) {
+            if (error_reporting() > 0 && $this->getParam('display_errors') && isset($m['file']) && isset($m['line'])) {
+                echo "\n<!-- [" . $m['file'] . ' : ' . $m['line'] . '] -->';
+            }
+            switch ($m['type']) {
             case MSG_ERR:
-                echo '<div class="sc-msg-error">' . $message['message'] . '</div>';
+                echo '<div class="sc-msg-error">' . $m['message'] . '</div>';
                 break;
 
             case MSG_WARNING:
-                echo '<div class="sc-msg-warning">' . $message['message'] . '</div>';
+                echo '<div class="sc-msg-warning">' . $m['message'] . '</div>';
                 break;
 
             case MSG_SUCCESS:
-                echo '<div class="sc-msg-success">' . $message['message'] . '</div>';
+                echo '<div class="sc-msg-success">' . $m['message'] . '</div>';
                 break;
 
             case MSG_NOTICE:
             default:
-                echo '<div class="sc-msg-notice">' . $message['message'] . '</div>';
+                echo '<div class="sc-msg-notice">' . $m['message'] . '</div>';
                 break;
 
@@ -477,4 +452,5 @@
             ?></div><?php
         }
+        $this->clearRaisedMessages();
     }
 
@@ -501,19 +477,15 @@
         static $previous_events = array();
 
-        if (!isset($_this) || !is_a($_this, 'App') && !is_subclass_of($_this, 'App')) {
-            $_this =& App::getInstance();
-        }
-
         // If priority is not specified, assume the worst.
-        if (!$_this->logPriorityToString($priority)) {
-            $_this->logMsg(sprintf('Log priority %s not defined. (Message: %s)', $priority, $message), LOG_EMERG, $file, $line);
+        if (!$this->logPriorityToString($priority)) {
+            $this->logMsg(sprintf('Log priority %s not defined. (Message: %s)', $priority, $message), LOG_EMERG, $file, $line);
             $priority = LOG_EMERG;
         }
 
         // If log file is not specified, don't log to a file.
-        if (!$_this->getParam('log_directory') || !$_this->getParam('log_filename') || !is_dir($_this->getParam('log_directory')) || !is_writable($_this->getParam('log_directory'))) {
-            $_this->setParam(array('log_file_priority' => false));
-            // We must use trigger_error to report this problem rather than calling App::logMsg, which might lead to an infinite loop.
-            trigger_error(sprintf('Codebase error: log directory (%s) not found or writable.', $_this->getParam('log_directory')), E_USER_NOTICE);
+        if (!$this->getParam('log_directory') || !$this->getParam('log_filename') || !is_dir($this->getParam('log_directory')) || !is_writable($this->getParam('log_directory'))) {
+            $this->setParam(array('log_file_priority' => false));
+            // We must use trigger_error to report this problem rather than calling $app->logMsg, which might lead to an infinite loop.
+            trigger_error(sprintf('Codebase error: log directory (%s) not found or writable.', $this->getParam('log_directory')), E_USER_NOTICE);
         }
 
@@ -531,5 +503,5 @@
             $previous_events[$msg_id]++;
             if ($previous_events[$msg_id] == 2) {
-                $_this->logMsg(sprintf('%s (Event repeated %s or more times)', $message, $previous_events[$msg_id]), $priority, $file, $line);
+                $this->logMsg(sprintf('%s (Event repeated %s or more times)', $message, $previous_events[$msg_id]), $priority, $file, $line);
             }
             return false;
@@ -543,5 +515,5 @@
             'remote ip' => getRemoteAddr(),
             'pid'       => (substr(PHP_OS, 0, 3) != 'WIN' ? posix_getpid() : ''),
-            'type'      => $_this->logPriorityToString($priority),
+            'type'      => $this->logPriorityToString($priority),
             'file:line' => "$file : $line",
             'url'       => (isset($_SERVER['REQUEST_URI']) ? $_SERVER['REQUEST_URI'] : ''),
@@ -550,11 +522,11 @@
 
         // FILE ACTION
-        if ($_this->getParam('log_file_priority') && $priority <= $_this->getParam('log_file_priority')) {
+        if ($this->getParam('log_file_priority') && $priority <= $this->getParam('log_file_priority')) {
             $event_str = '[' . join('] [', $event) . ']';
-            error_log($event_str . "\n", 3, $_this->getParam('log_directory') . '/' . $_this->getParam('log_filename'));
+            error_log($event_str . "\n", 3, $this->getParam('log_directory') . '/' . $this->getParam('log_filename'));
         }
 
         // EMAIL ACTION
-        if ($_this->getParam('log_email_priority') && $priority <= $_this->getParam('log_email_priority')) {
+        if ($this->getParam('log_email_priority') && $priority <= $this->getParam('log_email_priority')) {
             $subject = sprintf('[%s %s] %s', getenv('HTTP_HOST'), $event['type'], $message);
             $email_msg = sprintf("A %s log event occured on %s\n\n", $event['type'], getenv('HTTP_HOST'));
@@ -563,17 +535,17 @@
                 $email_msg .= sprintf("%-11s%s\n", $k, $v);
             }
-            mail($_this->getParam('log_to_email_address'), $subject, $email_msg, $headers, '-f codebase@strangecode.com');
+            mail($this->getParam('log_to_email_address'), $subject, $email_msg, $headers, '-f codebase@strangecode.com');
         }
 
         // SMS ACTION
-        if ($_this->getParam('log_sms_priority') && $priority <= $_this->getParam('log_sms_priority')) {
+        if ($this->getParam('log_sms_priority') && $priority <= $this->getParam('log_sms_priority')) {
             $subject = sprintf('[%s %s]', getenv('HTTP_HOST'), $priority);
             $sms_msg = sprintf('%s [%s:%s]', $event['message'], basename($file), $line);
             $headers = "From: codebase@strangecode.com";
-            mail($_this->getParam('log_to_sms_address'), $subject, $sms_msg, $headers, '-f codebase@strangecode.com');
+            mail($this->getParam('log_to_sms_address'), $subject, $sms_msg, $headers, '-f codebase@strangecode.com');
         }
 
         // SCREEN ACTION
-        if ($_this->getParam('log_screen_priority') && $priority <= $_this->getParam('log_screen_priority')) {
+        if ($this->getParam('log_screen_priority') && $priority <= $this->getParam('log_screen_priority')) {
             echo "[{$event['date']}] [{$event['type']}] [{$event['file:line']}] [{$event['message']}]\n";
         }
@@ -610,5 +582,5 @@
     /**
      * Sets which query arguments will be carried persistently between requests.
-     * Values in the _carry_queries array will be copied to URLs (via App::url()) and
+     * Values in the _carry_queries array will be copied to URLs (via $app->url()) and
      * to hidden input values (via printHiddenSession()).
      *
@@ -620,12 +592,8 @@
     function carryQuery($query_key)
     {
-        if (!isset($_this) || !is_a($_this, 'App') && !is_subclass_of($_this, 'App')) {
-            $_this =& App::getInstance();
-        }
-
         // If not already set, and there is a non-empty value provided in the request...
-        if (!isset($_this->_carry_queries[$query_key]) && getFormData($query_key, false)) {
+        if (!isset($this->_carry_queries[$query_key]) && getFormData($query_key, false)) {
             // Copy the value of the specified query argument into the _carry_queries array.
-            $_this->_carry_queries[$query_key] = getFormData($query_key);
+            $this->_carry_queries[$query_key] = getFormData($query_key);
         }
     }
@@ -652,10 +620,6 @@
     function url($url, $carry_args=null, $always_include_sid=false)
     {
-        if (!isset($_this) || !is_a($_this, 'App') && !is_subclass_of($_this, 'App')) {
-            $_this =& App::getInstance();
-        }
-
-        if (!$_this->running) {
-            $_this->logMsg(sprintf('Canceled method call %s, application not running.', __FUNCTION__), LOG_DEBUG, __FILE__, __LINE__);
+        if (!$this->running) {
+            $this->logMsg(sprintf('Canceled method call %s, application not running.', __FUNCTION__), LOG_NOTICE, __FILE__, __LINE__);
             return false;
         }
@@ -691,5 +655,5 @@
         if ($do_carry_queries) {
             // Join the global _carry_queries and local one_time_carry_queries.
-            $query_args = urlEncodeArray(array_merge($_this->_carry_queries, $one_time_carry_queries));
+            $query_args = urlEncodeArray(array_merge($this->_carry_queries, $one_time_carry_queries));
             foreach ($query_args as $key=>$val) {
                 // Check value is set and value does not already exist in the url.
@@ -715,7 +679,7 @@
                     (
                         !isset($_COOKIE[session_name()])
-                        || !$_this->getParam('session_use_cookies')
+                        || !$this->getParam('session_use_cookies')
                     )
-                    && $_this->getParam('enable_session')
+                    && $this->getParam('enable_session')
                     && isMyDomain($url)
                     &&
@@ -738,9 +702,9 @@
 
     /**
-     * Returns a HTML-friendly URL processed with App::url and & replaced with &amp;
+     * Returns a HTML-friendly URL processed with $app->url and & replaced with &amp;
      *
      * @access  public
      * @param   string  $url    Input URL to parse.
-     * @return  string          URL with App::url() and htmlentities() applied.
+     * @return  string          URL with $app->url() and htmlentities() applied.
      * @author  Quinn Comendant <quinn@strangecode.com>
      * @since   09 Dec 2005 17:58:45
@@ -748,9 +712,5 @@
     function oHREF($url, $carry_args=null, $always_include_sid=false)
     {
-        if (!isset($_this) || !is_a($_this, 'App') && !is_subclass_of($_this, 'App')) {
-            $_this =& App::getInstance();
-        }
-
-        $url = $_this->url($url, $carry_args, $always_include_sid);
+        $url = $this->url($url, $carry_args, $always_include_sid);
 
         // Replace any & not followed by an html or unicode entity with it's &amp; equivalent.
@@ -772,10 +732,6 @@
     function printHiddenSession($carry_args=null)
     {
-        if (!isset($_this) || !is_a($_this, 'App') && !is_subclass_of($_this, 'App')) {
-            $_this =& App::getInstance();
-        }
-
-        if (!$_this->running) {
-            $_this->logMsg(sprintf('Canceled method call %s, application not running.', __FUNCTION__), LOG_DEBUG, __FILE__, __LINE__);
+        if (!$this->running) {
+            $this->logMsg(sprintf('Canceled method call %s, application not running.', __FUNCTION__), LOG_NOTICE, __FILE__, __LINE__);
             return false;
         }
@@ -808,7 +764,7 @@
             // Join the global _carry_queries and local one_time_carry_queries.
             // urlencode is not used here, not for form data!
-            $query_args = array_merge($_this->_carry_queries, $one_time_carry_queries);
+            $query_args = array_merge($this->_carry_queries, $one_time_carry_queries);
             foreach ($query_args as $key=>$val) {
-                echo '<input type="hidden" name="' . $key . '" value="' . $val . '" />';
+                printf('<input type="hidden" name="%s" value="%s" />', $key, $val);
             }
         }
@@ -816,5 +772,5 @@
         // Include the SID if cookies are disabled.
         if (!isset($_COOKIE[session_name()]) && !ini_get('session.use_trans_sid')) {
-            echo '<input type="hidden" name="' . session_name() . '" value="' . session_id() . '" />';
+            printf('<input type="hidden" name="%s" value="%s" />', session_name(), session_id());
         }
     }
@@ -829,5 +785,5 @@
      *                                          or FALSE to prevent carrying queries. Can be any of the following formats:
      *                                          -array('key1', key2', key3')  <-- to save these keys if in the form data.
-     *                                          -array('key1'=>'value', key2'='value')  <-- to set keys to default values if not present in form data.
+     *                                          -array('key1' => 'value', key2' => 'value')  <-- to set keys to default values if not present in form data.
      *                                          -false  <-- To not carry any queries. If URL already has queries those will be retained.
      * @param   bool    $always_include_sid     Force session id to be added to Location header.
@@ -835,10 +791,6 @@
     function dieURL($url, $carry_args=null, $always_include_sid=false)
     {
-        if (!isset($_this) || !is_a($_this, 'App') && !is_subclass_of($_this, 'App')) {
-            $_this =& App::getInstance();
-        }
-
-        if (!$_this->running) {
-            $_this->logMsg(sprintf('Canceled method call %s, application not running.', __FUNCTION__), LOG_DEBUG, __FILE__, __LINE__);
+        if (!$this->running) {
+            $this->logMsg(sprintf('Canceled method call %s, application not running.', __FUNCTION__), LOG_NOTICE, __FILE__, __LINE__);
             return false;
         }
@@ -846,5 +798,5 @@
         if ('' == $url) {
             // If URL is not specified, use the redirect_home_url.
-            $url = $_this->getParam('redirect_home_url');
+            $url = $this->getParam('redirect_home_url');
         }
 
@@ -856,17 +808,17 @@
         }
 
-        $url = $_this->url($url, $carry_args, $always_include_sid);
+        $url = $this->url($url, $carry_args, $always_include_sid);
 
         header(sprintf('Location: %s', $url));
-        $_this->logMsg(sprintf('dieURL: %s', $url), LOG_DEBUG, __FILE__, __LINE__);
+        $this->logMsg(sprintf('dieURL: %s', $url), LOG_DEBUG, __FILE__, __LINE__);
 
         // End this application.
         // Recommended, although I'm not sure it's necessary: http://cn2.php.net/session_write_close
-        $_this->stop();
+        $this->stop();
         die;
     }
 
     /*
-    * Redirects a user by calling App::dieURL(). It will use:
+    * Redirects a user by calling $app->dieURL(). It will use:
     * 1. the stored boomerang URL, it it exists
     * 2. a specified $default_url, it it exists
@@ -876,5 +828,5 @@
     * @access   public
     * @param    string  $id             Identifier for this script.
-    * @param    mixed   $carry_args     Additional arguments to carry in the URL automatically (see App::oHREF()).
+    * @param    mixed   $carry_args     Additional arguments to carry in the URL automatically (see $app->oHREF()).
     * @param    string  $default_url    A default URL if there is not a valid specified boomerang URL.
     * @return   bool                    False if the session is not running. No return otherwise.
@@ -884,24 +836,20 @@
     function dieBoomerangURL($id=null, $carry_args=null, $default_url=null)
     {
-        if (!isset($_this) || !is_a($_this, 'App') && !is_subclass_of($_this, 'App')) {
-            $_this =& App::getInstance();
-        }
-
-        if (!$_this->running) {
-            $_this->logMsg(sprintf('Canceled method call %s, application not running.', __FUNCTION__), LOG_DEBUG, __FILE__, __LINE__);
+        if (!$this->running) {
+            $this->logMsg(sprintf('Canceled method call %s, application not running.', __FUNCTION__), LOG_NOTICE, __FILE__, __LINE__);
             return false;
         }
 
         // Get URL from stored boomerang. Allow non specific URL if ID not valid.
-        if ($_this->validBoomerangURL($id, true)) {
-            if (isset($id) && isset($_SESSION[$_this->app]['boomerang']['url'][$id])) {
-                $url = $_SESSION[$_this->app]['boomerang']['url'][$id];
-                $_this->logMsg(sprintf('dieBoomerangURL(%s) found: %s', $id, $url), LOG_DEBUG, __FILE__, __LINE__);
+        if ($this->validBoomerangURL($id, true)) {
+            if (isset($id) && isset($_SESSION[$this->_ns]['boomerang']['url'][$id])) {
+                $url = $_SESSION[$this->_ns]['boomerang']['url'][$id];
+                $this->logMsg(sprintf('dieBoomerangURL(%s) found: %s', $id, $url), LOG_DEBUG, __FILE__, __LINE__);
             } else {
-                $url = end($_SESSION[$_this->app]['boomerang']['url']);
-                $_this->logMsg(sprintf('dieBoomerangURL(%s) using: %s', $id, $url), LOG_DEBUG, __FILE__, __LINE__);
+                $url = end($_SESSION[$this->_ns]['boomerang']['url']);
+                $this->logMsg(sprintf('dieBoomerangURL(%s) using: %s', $id, $url), LOG_DEBUG, __FILE__, __LINE__);
             }
             // Delete stored boomerang.
-            $_this->deleteBoomerangURL($id);
+            $this->deleteBoomerangURL($id);
         } else if (isset($default_url)) {
             $url = $default_url;
@@ -909,19 +857,19 @@
             // Ensure that the redirecting page is not also the referrer.
             $url = getenv('HTTP_REFERER');
-            $_this->logMsg(sprintf('dieBoomerangURL(%s) using referrer: %s', $id, $url), LOG_DEBUG, __FILE__, __LINE__);
+            $this->logMsg(sprintf('dieBoomerangURL(%s) using referrer: %s', $id, $url), LOG_DEBUG, __FILE__, __LINE__);
         } else {
             // If URL is not specified, use the redirect_home_url.
-            $url = $_this->getParam('redirect_home_url');
-            $_this->logMsg(sprintf('dieBoomerangURL(%s) not found, using redirect_home_url: %s', $id, $url), LOG_DEBUG, __FILE__, __LINE__);
+            $url = $this->getParam('redirect_home_url');
+            $this->logMsg(sprintf('dieBoomerangURL(%s) not found, using redirect_home_url: %s', $id, $url), LOG_DEBUG, __FILE__, __LINE__);
         }
 
         // A redirection will never happen immediately twice.
         // Set the time so ensure this doesn't happen.
-        $_SESSION[$_this->app]['boomerang']['time'] = time();
-        $_this->dieURL($url, $carry_args);
-    }
-
-    /**
-     * Set the URL to return to when App::dieBoomerangURL() is called.
+        $_SESSION[$this->_ns]['boomerang']['time'] = time();
+        $this->dieURL($url, $carry_args);
+    }
+
+    /**
+     * Set the URL to return to when $app->dieBoomerangURL() is called.
      *
      * @param string  $url  A fully validated URL.
@@ -931,14 +879,10 @@
     function setBoomerangURL($url=null, $id=null)
     {
-        if (!isset($_this) || !is_a($_this, 'App') && !is_subclass_of($_this, 'App')) {
-            $_this =& App::getInstance();
-        }
-
-        if (!$_this->running) {
-            $_this->logMsg(sprintf('Canceled method call %s, application not running.', __FUNCTION__), LOG_DEBUG, __FILE__, __LINE__);
+        if (!$this->running) {
+            $this->logMsg(sprintf('Canceled method call %s, application not running.', __FUNCTION__), LOG_NOTICE, __FILE__, __LINE__);
             return false;
         }
         // A redirection will never happen immediately after setting the boomerangURL.
-        // Set the time so ensure this doesn't happen. See App::validBoomerangURL for more.
+        // Set the time so ensure this doesn't happen. See $app->validBoomerangURL for more.
 
         if ('' != $url && is_string($url)) {
